function AudioSynthView() {

    var isMobile = !!navigator.userAgent.match(/Android|BlackBerry|iPhone|iPad|iPod|Opera Mini|IEMobile/i);
    //isMobile = true;
    if(isMobile) { var evtListener = ['touchstart', 'touchend']; } else { var evtListener = ['mousedown', 'mouseup']; }

    //console.log("*** pointerEnabled: " + window.navigator.pointerEnabled);

    //var evtListener = ['pointerdown', 'pointerup']; 
    //var evtListener = ['touchstart', 'touchend']; 


    var __audioSynth = new AudioSynth();
    __audioSynth.setVolume(0.5);
    var __octave = 4;
    
    // Change octave
    var fnChangeOctave = function(x) {

	x |= 0;
	
	__octave += x;
	
	__octave = Math.min(5, Math.max(3, __octave));
	
	var octaveName = document.getElementsByName('OCTAVE_LABEL');
	var i = octaveName.length;
	while(i--) {
	    var val = parseInt(octaveName[i].getAttribute('value'));
	    octaveName[i].innerHTML = (val + __octave);
	    }
	
	document.getElementById('OCTAVE_LOWER').innerHTML = __octave-1;
	document.getElementById('OCTAVE_UPPER').innerHTML = __octave+1;
	
	};

    // Key bindings, notes to keyCodes.
    var keyboard = {
	
	/* 2 */
	50: 'C#,-1',
	
	/* 3 */
	51: 'D#,-1',
	
	/* 5 */
	53: 'F#,-1',
	
	/* 6 */
	54: 'G#,-1',
	
	/* 7 */
	55: 'A#,-1',
	
	/* 9 */
	57: 'C#,0',
	
	/* 0 */
	48: 'D#,0',
	
	/* + */
	187: 'F#,0',
	61: 'F#,0',
	
	/* Q */
	81: 'C,-1',
	
	/* W */
	87: 'D,-1',
	
	/* E */
	69: 'E,-1',
	
	/* R */
	82: 'F,-1',
	
	/* T */
	84: 'G,-1',
	
	/* Y */
	89: 'A,-1',
	
	/* U */
	85: 'B,-1',
	
	/* I */
	73: 'C,0',
	
	/* O */
	79: 'D,0',
	
	/* P */
	80: 'E,0',
	
	/* [ */
	219: 'F,0',
	
	/* ] */
	221: 'G,0',
	
	/* A */
	65: 'G#,0',
	
	/* S */
	83: 'A#,0',
	
	/* F */
	70: 'C#,1',
	
	/* G */
	71: 'D#,1',
	
	/* J */
	74: 'F#,1',
	
	/* K */
	75: 'G#,1',
	
	/* L */
	76: 'A#,1',
	
	/* Z */
	90: 'A,0',
	
	/* X */
	88: 'B,0',
	
	/* C */
	67: 'C,1',
	
	/* V */
	86: 'D,1',
	
	/* B */
	66: 'E,1',
	
	/* N */
	78: 'F,1',
	
	/* M */
	77: 'G,1',
	
	/* , */
	188: 'A,1',
	
	/* . */
	190: 'B,1'
	
	};
    
    var reverseLookupText = {};
    var reverseLookup = {};

    // Create a reverse lookup table.
    for(var i in keyboard) {
	
	var val;

	switch(i|0) {
	    
	    case 187:
	    val = 61;
	    break;
	    
	    case 219:
	    val = 91;
	    break;
	    
	    case 221:
	    val = 93;
	    break;
	    
	    case 188:
	    val = 44;
	    break;
	    
	    case 190:
	    val = 46;
	    break;
	    
	    default:
	    val = i;
	    break;
	    
	    }
	
	reverseLookupText[keyboard[i]] = val;
	reverseLookup[keyboard[i]] = i;
	
	}

    // Keys you have pressed down.
    var keysPressed = [];
    var visualKeyboard = null;
    var selectSound = null;

    var fnCreateKeyboard = function(keyboardElement) {
	// Generate keyboard
	// This is our main keyboard element! It's populated dynamically based on what you've set above.
	visualKeyboard = document.getElementById('keyboard');
	selectSound = document.getElementById('sound');

	var iKeys = 0;
	var iWhite = 0;
	var notes = __audioSynth._notes;

	for(var i=-1;i<=1;i++) {
	    for(var n in notes) {
		if(n[2]!='b') {
		    var thisKey = document.createElement('div');
		    if(n.length>1) {
			thisKey.className = 'black key';
			thisKey.style.width = '30px';
			thisKey.style.height = '120px';
			thisKey.style.left = (40 * (iWhite - 1)) + 25 + 'px';
			} else {
			    thisKey.className = 'white key';
			    thisKey.style.width = '40px';
			    thisKey.style.height = '200px';
			    thisKey.style.left = 40 * iWhite + 'px';
			    iWhite++;
			    }
		    var label = document.createElement('div');
		    label.className = 'label';
		    label.innerHTML = '<b>' + String.fromCharCode(reverseLookupText[n + ',' + i]) + '</b>' + '<br /><br />' + n.substr(0,1) +
			'<span name="OCTAVE_LABEL" value="' + i + '">' + (__octave + parseInt(i)) + '</span>' + (n.substr(1,1)?n.substr(1,1):'');
		    thisKey.appendChild(label);
		    thisKey.setAttribute('ID', 'KEY_' + n + ',' + i);
		    thisKey.addEventListener(evtListener[0], (function(_temp) { return function() { 
			console.log("**** bespoke evtListener for mousedown, away to call fnPlayKeyboard()");
			fnPlayKeyboard({keyCode:_temp}); } })(reverseLookup[n + ',' + i]));

		    visualKeyboard[n + ',' + i] = thisKey;
		    visualKeyboard.appendChild(thisKey);
		    iKeys++;
		    }
		}
	    }

	visualKeyboard.style.width = iWhite * 40 + 'px';

	window.addEventListener(evtListener[1], function() { n = keysPressed.length; while(n--) { fnRemoveKeyBinding({keyCode:keysPressed[n]}); } });
	
	};

    var midiMiddleC = 60;

    //var freqOctaveMap = {'C':261.63,'C#':277.18,'D':293.66,'D#':311.13,'E':329.63,'F':346.23,'F#':369.99,'G':392.00,'G#':415.30,'A':440.00,'A#':466.16,'B':493.88});

    var midiOctaveMap = {'C':0,'C#':1,'D':2,'D#':3,'E':4,'F':5,'F#':6,'G':7,'G#':8,'A':9,'A#':10,'B':11};

    var playedNotePitch;
    var playedMidiPitch;

    var playedNoteStartTime;
    var playedNoteStartCurrentTime;

    var playedDuration;


    // Creates our audio player
    var fnPlayNote = function(note, octave) {

	console.log("**** Note started: " + Date.now()/1000.0)

	playedNoteStartTime = Date.now();
	playedNoteStartCurrentTime = mediaPlayer.currentTime;

	playedNotePitch = "note = " + note + ",  octave = " + octave;
	playedMidiPitch = midiMiddleC + (12 * (octave-4)) +  midiOctaveMap[note];

	inTheGroove();
        MIDI.noteOn(0, playedMidiPitch, 50);

	//src = __audioSynth.generate(selectSound.value, note, octave, 2);
	//container = new Audio(src);
	//container.addEventListener('ended', function() { 
	//    container = null; 	    
	//});
	//container.addEventListener('loadeddata', function(e) { e.target.play(); });
	//container.autoplay = false;
	//container.setAttribute('type', 'audio/wav');
	/*document.body.appendChild(container);*/
	//container.load();
	//return container;
	return true;

	};

    // Detect keypresses, play notes.

    var fnPlayKeyboard = function(e) {
	console.log("***### fnPlayKeyboard() e=" + e); //JSON.stringify(e));

	// check to see if any modal dialogs are open
	var active_modal_dialogs = $('.ui-widget-overlay:visible');
	if (active_modal_dialogs.length>0) {
	    return false;
	}


	if (e.ctrlKey) {
	    // avoid playing a note if some kind of control-key
	    // combination (such a web page reload) is pressed
	    return false;
	}

	console.log("**** testing keyboard event key: '" + e.key + "' keycode = " + e.keyCode);

	var $focused = $(':focus');
	console.log("focused.id = " + $focused.attr("id"));

	if ($focused.attr("id") == "addCustomChordText") {
	    // The keyboard event isn't for us (i.e. the piano/drum input chain).  
	    // Return 'true' so the event can reach customGuitar keyboard handler
	    return true;
	}


	if (e.keyCode == 32) { // <space-bar>
	    togglePlayPause();
	    //e.preventDefault();
	    return false;
	}


	if (e.shiftKey) {
	    return fnDrumKeyboard(e);
	}

	if (e.altKey) {
	    return fnGuitarKeyboard(e);
	}
	

	var i = keysPressed.length;
	while(i--) {
	    if(keysPressed[i]==e.keyCode) {
		return false;
		}
	    }
	keysPressed.push(e.keyCode);
	
	switch(e.keyCode) {
	    
	    // left
	    case 37:
	    fnChangeOctave(-1);
	    break;
	    
	    // right
	    case 39:
	    fnChangeOctave(1);
	    break;
	    
	    // space
	    case 16:
	    break;
	    fnPlaySong([
		['E,0', 8],
		['D,0', 8],
		['C,0', 2],
		['C,0', 8],
		['D,0', 8],
		['C,0', 8],
		['E,0', 8],
		['D,0', 1],
		['C,0', 8],
		['D,0', 8],
		['E,0', 2],
		['A,0', 8],
		['G,0', 8],
		['E,0', 8],
		['C,0', 8],
		['D,0', 1],
		['A,0', 8],
		['B,0', 8],
		['C,1', 2],
		['B,0', 8],
		['C,1', 8],
		['D,1', 8],
		['C,1', 8],
		['A,0', 1],
		['G,0', 8],
		['A,0', 8],
		['B,0', 2],
		['C,1', 8],
		['B,0', 8],
		['A,0', 8],
		['G,0', 8],
		['A,0', 1]
		]);
	    break;
	    
	    }
	
	if(keyboard[e.keyCode]) {
	    if(visualKeyboard[keyboard[e.keyCode]]) {
		visualKeyboard[keyboard[e.keyCode]].style.backgroundColor = '#ff0000';
		visualKeyboard[keyboard[e.keyCode]].style.marginTop = '5px';
		visualKeyboard[keyboard[e.keyCode]].style.boxShadow = 'none';
		}
	    var arrPlayNote = keyboard[e.keyCode].split(',');
	    var note = arrPlayNote[0];
	    var octaveModifier = arrPlayNote[1]|0;
	    fnPlayNote(note, __octave + octaveModifier);
	    } else {
		return false;
	    }
	
	}

    // Remove key bindings once note is done.

    function calcMidiNoteInfo() {
    	if (mediaStartPlayTime != null) {
	    var playedNoteEndTime = Date.now();
	    var relativePlayedNoteStartTime = playedNoteStartTime - mediaStartPlayTime;
	    var relativePlayedNoteEndTime   = playedNoteEndTime - mediaStartPlayTime;
	    playedDuration = (relativePlayedNoteEndTime - relativePlayedNoteStartTime);


	    // console.log("**** " + playedNotePitch + " (midi pitch = " + playedMidiPitch+ ") startTime = ", relativePlayStartTime + ", duration = " + playedDuration);

	    // ***** xxxx
	    mediaPlayedNotes[String(mediaStartPlayTime)].push( 
		{ 'midiPitch'    : playedMidiPitch, 
		  'midiNoteOn'   : relativePlayedNoteStartTime,
		  'midiNoteOff'  : relativePlayedNoteEndTime,
		  'startCurrentTime' : playedNoteStartCurrentTime,
		  'duration'     : playedDuration,
		  'startPercTime': playedNoteStartCurrentTime/mediaPlayer.duration,
		  'humanReadble' : playedNotePitch }
	    );

	}
    }

    var fnRemoveKeyBinding = function(e) {
	
	console.log("**** key up at: " + Date.now())
	// console.log("*** event e = " + JSON.stringify(e));


	var i = keysPressed.length;
	while(i--) {
	    if(keysPressed[i]==e.keyCode) {
		if(visualKeyboard[keyboard[e.keyCode]]) {

		    delayedMissingTheGroove(500);

		    MIDI.noteOff(0, playedMidiPitch, 0);
		    if (mediaPlaybackMode == "record") {
			calcMidiNoteInfo();
		    }

		    visualKeyboard[keyboard[e.keyCode]].style.backgroundColor = '';
		    visualKeyboard[keyboard[e.keyCode]].style.marginTop = '';
		    visualKeyboard[keyboard[e.keyCode]].style.boxShadow = '';
		    }
		keysPressed.splice(i, 1);
		}
	    }
	
	}

    var fnPlaySong = function(arr) {
	
	if(arr.length>0) {
	    
	    var noteLen = 1000*(1/parseInt(arr[0][1]));
	    if(!(arr[0][0] instanceof Array)) {
		arr[0][0] = [arr[0][0]];
		}
	    var i = arr[0][0].length;
	    var keys = [];
	    while(i--) {
		keys.unshift(reverseLookup[arr[0][0][i]]);
		console.log("**** In fnPlaySong(), away to call fnPlayKeyboard()");
		fnPlayKeyboard({keyCode:keys[0]});
		}
	    arr.shift();
	    setTimeout(function(array, val){ return function() { var i = val.length; while(i--) { fnRemoveKeyBinding({keyCode:val[i]}); } fnPlaySong(array); } }(arr, keys), noteLen);
	    
	    }
	
	};

    var fnDrumKeyboard = function(e) {
	console.log("*** drum pressed keyCode: " + e.keyCode);
	if (e.keyCode == "C".charCodeAt(0)) {
	    $('#drum1').trigger("mousedown");
	}
	else if (e.keyCode == "V".charCodeAt(0)) {
	    $('#drum2').trigger("mousedown");
	}
	else if (e.keyCode == "B".charCodeAt(0)) {
	    $('#drum3').trigger("mousedown");
	}
	else if (e.keyCode == "N".charCodeAt(0)) {
	    $('#drum4').trigger("mousedown");
	}
	else if (e.keyCode == "M".charCodeAt(0)) {
	    $('#drum5').trigger("mousedown");
	}

	//e.preventDefault();
	return true; // let other things outside of this piano/drum chain (such as the customGuitar input) see the event
    }





    var fnGuitarKeyboard = function(e) {
	console.log("*** guitar pressed keycode: " + e.keyCode);
	if (e.keyCode == "Q".charCodeAt(0)) {
	    $('#offscreen-jtab-chord-0').trigger("click");
	}
	else if (e.keyCode == "W".charCodeAt(0)) {
	    $('#offscreen-jtab-chord-3').trigger("click");
	}
	else if (e.keyCode == "E".charCodeAt(0)) {
	    $('#offscreen-jtab-chord-6').trigger("click");
	}
	else if (e.keyCode == "R".charCodeAt(0)) {
	    $('#offscreen-jtab-chord-7').trigger("click");
	}
	else if (e.keyCode == "T".charCodeAt(0)) {
	    $('#offscreen-jtab-chord-10').trigger("click");
	}
	else if (e.keyCode == "Y".charCodeAt(0)) {
	    $('#offscreen-jtab-chord-13').trigger("click");
	}
	else if (e.keyCode == "U".charCodeAt(0)) {
	    $('#offscreen-jtab-chord-16').trigger("click");
	}


	e.preventDefault();
	return true; // let other things outside of this piano/guitar chain see the event
    }



    // Set up global event listeners

    window.addEventListener('keydown', fnPlayKeyboard);
    window.addEventListener('keyup', fnRemoveKeyBinding);
    document.getElementById('-_OCTAVE').addEventListener('click', function() { fnChangeOctave(-1); });
    document.getElementById('+_OCTAVE').addEventListener('click', function() { fnChangeOctave(1); });
    
    Object.defineProperty(this, 'draw', {
	value: fnCreateKeyboard
	});

}
